CvrStgObject Class Referenceabstract

an object that can hold embedded data More...

`#include <CvrStgObject.h>`

Inheritance diagram for CvrStgObject:

## Public Member Functions

virtual unsigned long | getNumSamples (void) const =0
virtual SampleValue * | getSampleValue (const SamplePos pos) const =0
virtual void | replaceSample (const SamplePos pos, const SampleValue *s)=0

## Detailed Description

This abstract base class provides an interface for every class that is able to hold embedded data. Something that can hold embedded data is essentially though of as an array of samples.

Definitions: Embedded Bit...a bit to be embedded (one bit in the original or extracted embfile) Sample...the smallest data unit in a file (e.g. a RGB triple, a DCT coefficient)

## Member Function Documentation

## getNumSamples()

virtual unsigned long CvrStgObject::getNumSamples | ( | void |  | ) | const

pure virtual

get the number of samples in this CvrStgObject

Implemented in AudioDataImpl< Type, ValueType, SampleValueType >, AudioDataImpl< AuMuLaw, BYTE >, AudioDataImpl< AuPCM16, SWORD16 >, AudioDataImpl< AuPCM32, SWORD32 >, AudioDataImpl< AuPCM8, SBYTE >, AuFile, BmpFile, DummyFile, and WavFile.

## getSampleValue()

virtual SampleValue * CvrStgObject::getSampleValue | ( | const SamplePos | pos | ) | const

pure virtual

get the sample at position pos

Parameters

  pos | the position of a sample (must be in 0...getNumSamples()-1)

Returns
  the sample at the given position

The sample object is created in this function and should be deleted by the caller. The derived class should check the condition(s) given above in its Implementation of this function.

Implemented in AudioDataImpl< Type, ValueType, SampleValueType >, AudioDataImpl< AuMuLaw, BYTE >, AudioDataImpl< AuPCM16, SWORD16 >, AudioDataImpl< AuPCM32, SWORD32 >, AudioDataImpl< AuPCM8, SBYTE >, AuFile, BmpFile, DummyFile, and WavFile.

## replaceSample()

virtual void CvrStgObject::replaceSample | ( | const SamplePos | pos,
|  | const SampleValue * | s )

pure virtual

replace a sample thus (possibly) altering the value of the bit returned by SampleValue->getBit()

Parameters

  pos | the position of the sample (must be in 0...getNumSamples()-1)
  s | the sample value that should replace the current sample value (must be of correct type for this CvrStgObject)

The derived class should check the condition(s) given above in its Implementation of this function.

Implemented in AudioDataImpl< Type, ValueType, SampleValueType >, AudioDataImpl< AuMuLaw, BYTE >, AudioDataImpl< AuPCM16, SWORD16 >, AudioDataImpl< AuPCM32, SWORD32 >, AudioDataImpl< AuPCM8, SBYTE >, AuFile, BmpFile, DummyFile, and WavFile.

The documentation for this class was generated from the following file:

- CvrStgObject.h